CON
{''Hardware version 3.11 - see diagram.
''
} 
 _clkmode       = xtal1 + pll16x                        ' use crystal x 16
 _xinfreq       = 5_000_000                             'with 5mhz crystal 
      
  DEV_SD_CLK        = 18
  DEV_SD_DI         = 19
  DEV_SD_DO         = 20                                 
  DEV_SPI_EN        = 21                               ''SPI Enable enumeration
  DEV_SPI_ADD0      = 22                               ''Device address 0 enumeration
  DEV_SPI_ADD1      = 23                               ''Device address 1 enumeration
  DEV_SPI_ADD_LE    = 24
  
  DEV_SPI_LCD_RES    = 0                 ''Device id for LCD reset
  SDC     = 1
  TSC     = 2
  EXT     = 3  
 DEV_SPI_EXT_POT_CS  = 0
 DEV_SPI_EXT_SW_CS   = 1
                      
  BGCOLOR                       = $ffff
  TXTCOLOR                      = $0000
   Pressed                       = 1  
   NotPressed                    = 0
faderUpBtnBound                 = 499     ''y < 499
faderDnBtnBound                 = 3700    ''y > 3699                  3200, 1600, 320
fadertouchoffset                = 320         ''3375 < y < 825  range e

  cols = 40
  rows = 15
  screensize = cols * rows
  lastrow = screensize - cols
  offset = 8 * 2048 ' the block offset of where we do writes 

  RamText   = 169984
  VT100     = 202752
  FontTable = 206080 


VAR
 long Screen_Buffer, CRbuffer

 
    byte FontHeight                ' size of the current loaded font (pixels = fontsize *.75)
   word BackFontColor           ' the background color in RRRRRGGG GGGBBBBB format
   word curx                    ' current cursor x position in pixels
   word cury                    ' current cursor y position in pixels
   byte Orientation                ' true for portrait, false for landscape
   word ScreenWidth             ' either 240 in portrait or 320 in landscape
   word ScreenHeight            ' 320 in portrait or 240 in landscape
   byte screen[screensize]
   long col,row,flag
  
 
   'byte  font[13312], sdbuffer[512],buffer2[512]                     ' 512 byte buffer for sd card interface
                                 
   'byte tbuf[20]
   'byte bigbuf[8192]
   
   long BackgroundColor, ActiveTextColor, stringptr[32], maxdur,sr ,speedresults 
           
OBJ pfw :"PropFont_asmDone"
     wait : "timing"  
     'pst : "parallax serial terminal"
     spi : "spi_asm"
     sdfat: "fsrw"
      'block: "safe_spi"
     'ILI9325:"ILI9325_Dracblade"       
PUB BOOT   | f                       'bootstrap, initalizes pins, then starts pst, init display, start asm, clear screen and display hello world
  WAIT.PAUSE1S(5)
  initPins


SetOrientation(false)
  
BackgroundColor := $ffe0
ActiveTextColor := %0000  
 long[@Screen_Buffer]          := $ffff                        'make sure screen buffer does not equal 0  
  pfw.Start(@Long[@Screen_Buffer])                          'Start Asm Driver, needs to be changed to pass screen buffer from top object
  pfw.size(1)
  pfw.setChar(0, 8, 0, 0, BackgroundColor, ActiveTextColor)
  spi.start(3,0) 
   'pfw.ClearScreen(BackgroundColor)            'Draw White Screen with asm
  ' DracFont
   'pfw.dec(\SD_speedtest)
   'wait.pause1s(5)
   repeat 
     DracFont

Pub DracFont |c
'pfw.clearscreen($FFFF)
pfw.size(2)            
'pfw.str(string("  setting enable output  "))
  OUTA[DEV_SPI_EN] := 1    
  outa[DEV_SPI_ADD1..DEV_SPI_ADD0] := SDC
  dira[DEV_SPI_EN..DEV_SD_CLK] := 0
  dira[DEV_SPI_ADD1..DEV_SPI_ADD0] := 3
'pfw.newline    
'pfw.str(string("  setting enable output ok  "))
'pfw.newline
'pfw.str(string("  trying to mount sd card  "))  
  'pfw.newline
  'wait.pause1s(1)               
    if \sdfat.mount(18) < -1
     ' pfw.str(string("Mount Failed"))
      'wait.pause1s(3)
      sdfat.unmount
    else
    'pfw.str(string("  Mounting OK  "))
    \NewFont(string("Par16.ifn"))
    sdfat.unmount
    Text_cls

     'tswait
     repeat
        repeat c from 32 to 125
       
          wait.pause1ms(100)
          text_out(c)     '
   
   ' Text_str(string("ABCDEFGHIJKLMNOPQRSTUVWXYZ abcdefghijklmnopqrstuvwxyz")) 
    Text_str(string("Basic text display for the ILI9325"))
     
    Text_crlf
    Text_str(string("Print decimal value "))
    Text_dec(100)
    Text_crlf
    text_str(string("Hex value 500 = "))
    Text_hex(500,4)
    text_crlf    
   'wait.pause1s(5)

   
PUB Text_Str(rstringptr)
'' Print a zero-terminated string
  repeat strsize(rstringptr)
    Text_out(byte[rstringptr++])

PUB Text_out(c) | i, k
'' Output a character
''
''     $08 = backspace
''     $09 = tab (8 spaces per)
''     $01 = set X position (X follows)
''     $0B = set Y position (Y follows)
''     $0C = set color (color follows)  (not on this simple terminal)
''     $0A = line feed
''     $0D = carriage return (col = 0)
''  others = printable characters

  case flag
    $00: case c
           $08: if col        ' not zero so can subtract one
                  col--
                  Text_print(" ")     ' backspace and rubout
                  col--
                  'Text_RedrawLine
           $09: repeat
                  Text_print(" ")
                while col & 7
           $01: flag := c
             return
           $0B: flag := c
             return
           $0C: flag := c
             return
           $0A: Text_newline ' linefeed/new line     
           $0D: col := 0 ' carriage return
           other: Text_print(c)
    $0A: col := c // cols
    $0B: row := c // rows
    '$0C: color := c & 7
  flag := 0
  
PRI Text_print(c)         ' private routine from routine above
  screen[row * cols + col] := c  ' store in the screen text buffer
  ILIChar(c,col<<3,row <<4)   ' print on the screen  col*8 and row *16 as this is the font size
  if ++col == cols
    Text_newline       '
   
PUB Text_hex(value, digits)
  {{ Send value as hexadecimal characters up to digits in length.
  ''
  '' `Parameters:
  ''
  ''     `value: byte, word, or long value to send as hexadecimal characters.
  ''     `digits: number of hexadecimal digits to send.  Will be zero padded if necessary.
  ''
  '' `Return: none.
  ''
  '' `Example: pst.Hex(1234, 5)
  ''
  ''     Output decimal 1234 as five hex digits. Outputs `004D2.
  ''     Next lines, if needed...
  }}

  if (digits > 8)
    repeat digits - 8
      Text_out("0")
    digits := 8
  else
    value <<= (8 - digits) << 2
  repeat digits
    Text_out(lookupz((value <-= 4) & $F : "0".."9", "A".."F"))
        
PUB Text_dec(value) | i
'' Print a decimal number
  if value < 0
    -value
    Text_out("-")
  i := 1_000_000_000
  repeat 10
    if value => i
      Text_out(value / i + "0")
      value //= i
      result~~
    elseif result or i == 1
      Text_out("0")
    i /= 10
    
PRI Text_newline | i
  col := 0
  if ++row == rows
    row--
    bytemove(@screen, @screen[cols], lastrow)   'scroll lines
    bytefill(@screen[lastrow], " ", cols)      'clear new line
    Text_RedrawScreen                                   ' all lines shuffle up one so need to redraw all the screen

PUB Text_RedrawScreen | x,y,i
    ClearFontBackground(0,0,screenheight,screenwidth)
    ILIsetcursor(0,0)
    i := 0
    repeat y from 0 to rows -1
      repeat x from 0 to cols -1
        curx := ILIChar(screen[i],curx,cury)
        i++
      curx :=0
      cury +=fontheight

PRI Text_RedrawLine | oldcurx,i ' redraw current row, for backspace
   oldcurx := curx' store
   ClearFontBackground(0,row <<4 ,screenwidth,row <<4 + FontHeight) ' clear background line to the background color ready to draw
   curx := 0
   cury := row <<4 ' times 16
   i := row * cols ' variable row times constant cols
   repeat cols ' do 40x
     curx := ILIChar(screen[i],curx,cury)
     i++
   curx := oldcurx              ' restore curx
   
PUB ILIChar(ascii,x,y) | jump,size,width,height,ramaddress,xoffset,yoffset,xadvance   ' read out a character from a .ifn file stored in ram
    jump := long[@font + (ascii << 2) +  256]' jump location = ascii *4 plus fonttable + 256
    jump += @font
    size := long[jump]                 ' size precalculated = width x height x 2
    xadvance :=  long[jump][5]     '     ' amount to move to next character offset = 20 which is 5 longs
    if size > 0 and ascii <> 32          ' no need to print anything if size is zero or read more font data
      width :=   long[jump][1]                ' width value of offset is 1 long
      height :=  long[jump][2]            ' height
      xoffset := long[jump][3]          ' xoffset to move
      yoffset := long[jump][4]           ' yoffset to move
      if (x+width -1 + xoffset) > screenwidth
        ILIcrlf ' do a new line if it won't fit
        x :=curx                                           
        y :=cury
      pfw.draw( x+xoffset, y+yoffset, x+width-1+xoffset,y+height-1+yoffset)      ' draw on screen
      pfw.hub(jump+32,size)                                 ' move bytes from ram out to the display   
    return x + xadvance

PUB SetOrientation(e) ' change orientation true = portrait. Changes global variable 'orientation' and also screen width and height
    orientation := e
    pfw.ChangeOrientation(orientation)
    if orientation
      screenwidth :=239
      screenheight :=319
    else
      screenwidth :=319
      screenheight :=239

PUB Text_crlf
   Text_out(13)
   Text_out(10)   
      
PUB Text_cls
   bytefill(@screen, " ", screensize)
   col := row := 0
   
PUB ILISetCursor(x,y)            
    curx := x
    cury := y
    
PUB ILIcrlf
    curx := 0
    cury += FontHeight
    
PUB NewFont(nstrpointer)
    ILIloadfont(nstrpointer)
    ' only call this routine with the cursor curx at zero
    'pfw.newline
    'pfw.str(string("calling font clear with curx"))
   ' pfw.dec(curx)
    'pfw.newline
    'pfw.str(string("cury"))
   ' pfw.dec(cury)
    'pfw.newline
    'pfw.str(string("screenwitdth"))
    'pfw.dec(screenwidth)
    'pfw.newline
   ' pfw.str(string("screenheight"))
    'pfw.dec(screenheight)
    'pfw.newline
   ''tswait
    'pfw.str(string("go"))
    ClearFontBackground(0,0,screenheight,screenwidth)             ' clear an area the same color as the font background
    'pfw.str(string("cleared?"))
    ILIsetcursor(0,0)

PUB ILILoadFont(nstringptr)| filesize,i   ' hub version
    ' pass file name in stringptr
    ' the variable "i" must start on 0,256,512,768 etc for the block move to work
    i := 0
    'pfw.newline
    'pfw.str(string("Opening file "))
    'pfw.str(nstringptr)
    'pfw.newline                                            
    sdfat.popen(nstringptr,"r")                        ' store at the constant 'fonttable' location 
    'pfw.str(string("Opening file ok "))
    'pfw.newline
    'pfw.str(string("Getting filesize"))
    'pfw.newline
    filesize := sdfat.get_filesize
    'pfw.str(string("Filesize is "))
    'pfw.dec(filesize)
    'pfw.newline
    'pfw.str(string("loading font into hub"))
    'pfw.newline
    repeat (filesize >> 8)                              ' read in this number of 256 byte blocks
      sdfat.pread(@font+i,256)                         ' get 256 bytes from sd card
      i += 256                                         ' add 256
    'pfw.str(string(" read complete "))
    'pfw.newline
    'pfw.str(string(" closing filesystem ")) 
    sdfat.pclose
    'pfw.str(string(" closed "))
    'pfw.newline
    'pfw.str(string("loading font height"))  
   FontHeight := font[251]
   'pfw.dec(FontHeight)
   'pfw.newline
   'pfw.str(string("getting bgcolor"))
   'pfw.newline 
   repeat i from 0 to 2
      sdbuffer[i] := font[35+i]                         ' read the 3 RGB bytes
  'pfw.str(string("bg color is "))
  'repeat i from 0 to 2
  'pfw.dec(sdbuffer[i])
  'pfw.newline 
  'pfw.str(string("converting colors "))
  pfw.convertColors(@sdbuffer,@buffer2,1)
  'pfw.str(string("conversion done"))
  'tswait
  'pfw.clearscreen($4893)
  'pfw.str(string("new colors are"))  
  BackFontColor := word[@buffer2]                  ' background color in ILI two byte format
    'pfw.dec(BackFontColor)
    'pfw.newline
    'pfw.str(string("returing with filesize"))
    'pfw.dec(filesize)
    result := filesize
  ''tswait

PUB ClearFontBackground(x1,y1,x2,y2) | i,size,remainder ' clears an area of the screen to the current font background color
    size := (x2-x1+1) * (y2 - y1 +1)               ' number of pixels
    remainder := (size & 255) << 1                      ' if not a whole number of 256 pixels
    repeat i from 0 to 510 step 2                         ' move the background font colour to the buffer
      sdbuffer[i] := BackFontColor & 255                  ' and replicate for 256 pixels
      sdbuffer[i+1] := BackFontColor >> 8
    pfw.draw(y1,x1,y2,x2)                           ' set up the area of the screen to draw in
    repeat size >> 8                                    ' 512 byte blocks
      pfw.hub(@sdbuffer,512)                ' 2 = 2 bytes which = one pixel   *was 512
    if remainder <> 0  
      pfw.hub(@sdbuffer,remainder)           ' do the remainder
       
PUB TSWait  | yval, xval,x,y
  OUTA[DEV_SPI_ADD1..DEV_SPI_ADD0] := TSC        ''Old format was      OUTA[TS_CS] := 0     ' enable the touch screen    '  
  dirA[DEV_SPI_EN] := 1 
  dirA[DEV_SPI_ADD1] :=1
  dirA[DEV_SPI_ADD0] := 1 
   outa[DEV_SPI_EN] := 1   
  wait.pause1ms(100)
   repeat
     OUTA[DEV_SPI_EN] := 0
      SPI.SHIFTOUT(DEV_SD_DI, DEV_SD_CLK, 5, 8 , %1101_0000)  ' reads x from  500 to 3700  (off < 500 )
      xval := SPI.SHIFTIN(DEV_SD_DO, DEV_SD_CLK,2, 12)
      SPI.SHIFTOUT(DEV_SD_DI, DEV_SD_CLK, 5, 8 , %1001_0000)  ' reads y from 400 to 3800 (off > 3800 ) 
      yval := SPI.SHIFTIN(DEV_SD_DO,DEV_SD_CLK,2, 12)
       if xval <>  0
         result := xval + (yval << 16)
         OUTA[DEV_SPI_EN] := 1
         outa[DEV_SPI_ADD1..DEV_SPI_ADD0] := SDC
         RETURN
       ELSE 
         wait.pause1ms(100)

PUB StrobeCS
   OUTA[DEV_SPI_EN] := 0
   wait.pause1ms(10)
   OUTA[DEV_SPI_EN] := 1

pri initPins
  dirA[DEV_SPI_ADD0]   := 1             'makes address 0 and 1          
  dirA[DEV_SPI_ADD1]   := 1             'outputs
  dirA[DEV_SPI_EN]     := 1              'and enable an output as well
  OUTA[DEV_SPI_ADD1..DEV_SPI_ADD0] := 2   'sd_card is default
  OUTA[DEV_SPI_EN]     := 1             'Disable - Reset Screen
      
'pri SD_speedtest | r, sta, bytes, CHAR                 ''works?
' OUTA[DEV_SPI_EN] := 1    
' outa[DEV_SPI_ADD1..DEV_SPI_ADD0] := SDC
' dira[DEV_SPI_EN..DEV_SD_CLK] := 0
' dira[DEV_SPI_ADD1..DEV_SPI_ADD0] := 3
' pfw.size(2)
' pfw.clearscreen(0)
' pfw.setColors($0000,$FFFF)  
' pfw.Str(string("Starting SD card"))        ' helpful message if card is out, better than just a blank screen
' pfw.newline                          
' Pfw.str(string("Mounting."))
 ' pfw.newline   
  ' sdfat.mount(18)
  ' Pfw.str(string("Mounted."))
  ' pfw.newline
  ' wait.Pause1s(1)
  ' Pfw.str(string("Dir:"))
  ' pfw.newline
  ' sdfat.opendir
  ' repeat while 0 == sdfat.nextfile(@tbuf)
  '   Pfw.str(@tbuf)
  '   Pfw.newline     
  ' Pfw.str(string("That's the dir"))     
  ' sta := cnt
  ' r := sdfat.popen(string("speed.txt"), "w")
  ' repeat 256                  
  '   sdfat.pwrite(@bigbuf, 8192)                  
   'r := (cnt - sta) >> 2
  ' sdfat.pclose
   'pfw.newline
   'Pfw.str(string("Writing 2M took "))
  ' pfw.dec(r)
   'Pfw.newline
   'sta := cnt
   'r := sdfat.popen(string("speed.txt"), "r")
   'repeat 256
   '  sdfat.pread(@bigbuf, 8192)
   'r := (cnt - sta) >> 2     
   'sdfat.pclose
   'sdfat.release
   'sdfat.unmount
   'Pfw.str(string("Reading 2M took "))
   'pfw.dec(r)
   'Pfw.newline
   'Pfw.str(string("That's, all, folks! "))
   'pfw.size(1) 
   'tswait    
'pub deadend                                                               'loop for testing
' repeat                                                                             'endlessly wait
'   repeat
'    waitcnt(2_000 + cnt)

DAT
sdbuffer        byte    $0[512]  ' 512 byte buffer for sd card interface
buffer2         byte    $0[512]  ' 512 general purpose hub buffer
font            byte    $0[13312]